package edu.berkeley.edu.cs160.groupjybz.realdealprototype;

import android.content.Context;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

public class AddPromotion extends Activity {
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        addPromotionMenu();
    }
    
    private void addPromotionMenu() {
    	final Context mContext = this;
        setContentView(R.layout.addpromotion);

    	final EditText storeName = (EditText) findViewById(R.id.storeName);
    	final EditText description = (EditText) findViewById(R.id.description);
    	final EditText location = (EditText) findViewById(R.id.location);
    	final EditText keyWord = (EditText) findViewById(R.id.keyWord);
    	final Spinner types = (Spinner) findViewById(R.id.type);
    	storeName.requestFocus();
    	ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(
                this, R.array.types, R.layout.spinner_dropdown_view);
        adapter.setDropDownViewResource(R.layout.spinner_dropdown_item);
        types.setAdapter(adapter);
        
        location.setText(RealDealPrototypeActivity.getCurrentAddress());
        
    	Button cancel = (Button) findViewById(R.id.cancel);
    	cancel.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				setResult(RESULT_CANCELED, null, null);
                finish();
			}
		});
    	final Button save = (Button) findViewById(R.id.save);
    	save.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				Toast.makeText(mContext, "Promotion Added", Toast.LENGTH_SHORT).show();
				Bundle bundle = new Bundle();
				/*To be added for saving result */
				String keyword = keyWord.getText().toString();
				bundle.putString(RealDealDbAdapter.KEY_KEYWORD, keyword);
				String storename = storeName.getText().toString();
				bundle.putString(RealDealDbAdapter.KEY_STORENAME, storename);
				String loc = location.getText().toString();
				bundle.putString(RealDealDbAdapter.KEY_LOCATION, loc);
				String desc = description.getText().toString();
				bundle.putString(RealDealDbAdapter.KEY_DESCRIPTION, desc);
				
				bundle.putString(RealDealDbAdapter.KEY_TYPE,types.getSelectedItem().toString());
				
				setResult(RESULT_OK, null, bundle);
                finish();
			}
		});
    	Button preview = (Button) findViewById(R.id.preview);
    	preview.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				goMap();
			}
		});
        types.setOnKeyListener(new View.OnKeyListener(){
        	public boolean onKey(View view, int keyCode, KeyEvent event) {
        		if (keyCode == KeyEvent.KEYCODE_DPAD_RIGHT) {
        			save.requestFocus();
        			return true;
        		} else if (keyCode == KeyEvent.KEYCODE_DPAD_LEFT) {
        			return true;
        		}
        		return false;
        	}
        });
    }
    
    public final static int ACTIVITY_MAP = 10;
    
    public void goMap() {
    	Intent i = new Intent(this, MyDrivingDirectionsActivity.class);
    	i.putExtra("place holder", "place holder");
        startSubActivity(i, ACTIVITY_MAP);
    }
    
	@Override
	protected void onFreeze(Bundle outState) {
		// TODO Auto-generated method stub
		super.onFreeze(outState);
	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		addPromotionMenu();
	}
    
	protected void onActivityResult(int requestCode, int resultCode,
			String data, Bundle extras) {
		// TODO Auto-generated method stub
		super.onActivityResult(requestCode, resultCode, data, extras);
		switch(requestCode) {
        case ACTIVITY_MAP:
        	addPromotionMenu();
        	break;
		}
	}
    
    
}