package edu.berkeley.edu.cs160.groupjybz.realdealprototype;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.Menu.Item;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Button;
import android.widget.Toast;

public class AdvancedSearch extends Activity {
    
	private Context mContext = this;
	
	public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        advancedSearch();
    }
    
    private void advancedSearch() {
    	setContentView(R.layout.advancedsearch);

    	final EditText storeName = (EditText) findViewById(R.id.storenameinput);
    	final EditText keyWord = (EditText) findViewById(R.id.keywordinput);
    	final EditText distance = (EditText) findViewById(R.id.distanceinput);
    	final EditText location = (EditText) findViewById(R.id.locationinput);
    	final EditText voteRatio = (EditText) findViewById(R.id.voteratioinput);
    	final Spinner types = (Spinner) findViewById(R.id.typespinner);
    	final Spinner distanceUnit = (Spinner) findViewById(R.id.distancespinner);
    	
    	ArrayAdapter<CharSequence> tAdapter = ArrayAdapter.createFromResource(
                this, R.array.types, R.layout.spinner_dropdown_view);
        tAdapter.setDropDownViewResource(R.layout.spinner_dropdown_item);
        types.setAdapter(tAdapter);
        types.setOnKeyListener(new View.OnKeyListener(){
        	public boolean onKey(View view, int keyCode, KeyEvent event) {
        		if (keyCode == KeyEvent.KEYCODE_DPAD_LEFT) {
        			return true;
        		} else if (keyCode == KeyEvent.KEYCODE_DPAD_RIGHT) {
        			return true;
        		}
        		return false;
        	}
        });
        
        ArrayAdapter<CharSequence> dAdapter = ArrayAdapter.createFromResource(
                this, R.array.distance_units, R.layout.spinner_dropdown_view);
        dAdapter.setDropDownViewResource(R.layout.spinner_dropdown_item);
        distanceUnit.setAdapter(dAdapter);
        distanceUnit.setOnKeyListener(new View.OnKeyListener(){
        	public boolean onKey(View view, int keyCode, KeyEvent event) {
        		if (keyCode == KeyEvent.KEYCODE_DPAD_LEFT) {
        			distance.requestFocus();
        			return true;
        		} else if (keyCode == KeyEvent.KEYCODE_DPAD_RIGHT) {
        			return true;
        		}
        		return false;
        	}
        });
        Button back = (Button) findViewById(R.id.back);
		back.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				setResult(RESULT_CANCELED, null, null);
                finish();
			}
		});
		
		Button search = (Button) findViewById(R.id.search);
		search.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				Bundle bundle = new Bundle();
				String storename = storeName.getText().toString();
				bundle.putString(RealDealDbAdapter.KEY_STORENAME, storename);
				String keyword = keyWord.getText().toString();
				bundle.putString(RealDealDbAdapter.KEY_KEYWORD, keyword);
				String loc = location.getText().toString();
				bundle.putString(RealDealDbAdapter.KEY_LOCATION, loc);
				
				
				String d = distance.getText().toString();
				if (d.length()>0) {
					double dis = Double.valueOf(distance.getText().toString()).doubleValue();
					bundle.putDouble(RealDealDbAdapter.KEY_DIS, dis);
				}
				String r = voteRatio.getText().toString();
				if (r.length()>0)
				{
					double vratio = Double.valueOf(voteRatio.getText().toString()).doubleValue();
					vratio = vratio / (double)100;
					if (vratio >= 0 && vratio <= 1)
					{
						bundle.putDouble(RealDealDbAdapter.KEY_VOTERATIO, vratio);
					}
					//Toast.makeText(mContext, Double.toString(vratio), Toast.LENGTH_SHORT).show();
				}
				bundle.putString(RealDealDbAdapter.KEY_TYPE,types.getSelectedItem().toString());
				setResult(RESULT_OK, null, bundle);
                finish();
			}
		});
    }
}