package edu.berkeley.edu.cs160.groupjybz.realdealprototype;

import android.graphics.Canvas;
import android.graphics.Paint;
import com.google.android.maps.Overlay;
import com.google.android.maps.Point;
import com.google.android.maps.Overlay.PixelCalculator;

public class MapOverlay extends Overlay {
	private Point[] mLocations;
	
	public MapOverlay(Point[] points) {
		mLocations = points;
	}
	
	public void draw(Canvas canvas, PixelCalculator calculator, boolean shadow) {
		super.draw(canvas, calculator, shadow);
		for(int i=0; i<mLocations.length; i++) {
			int[] coords = new int[2];
			calculator.getPointXY(mLocations[i], coords);
			float latitude = coords[0];
			float longitude = coords[1];
			Paint white = new Paint();
			white.setARGB(255, 255, 255, 255);
			canvas.drawCircle(latitude,longitude,8,new Paint());
			canvas.drawPosText(Integer.toString(i+1), new float[]{ latitude-4,longitude+4 }, white);
		}
	}
}