package edu.berkeley.edu.cs160.groupjybz.realdealprototype;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

public class PromotionDescription extends Activity 
{
	private RealDealDbAdapter mDbHelper;
	private Long mRowId;
	private TextView mStoreNameText;
	private TextView mTypeText;
	private TextView mDescriptionText;
	private TextView mLocationText;
	private TextView mDisText;
	private TextView mVoteText;
	private Integer uv;
	private Integer tv;
	private Cursor mPromotion;
	private Context mContext = this;
	
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        promotionMenu(icicle);
    }
    
    private void promotionMenu(final Bundle icicle) 
    {
    	mDbHelper = new RealDealDbAdapter(this);
        mDbHelper.open();
    	
        setContentView(R.layout.promotiondescription);
        
        mStoreNameText = (TextView) findViewById(R.id.storenamecontent);
        mTypeText = (TextView) findViewById(R.id.typecontent);
        mDescriptionText = (TextView) findViewById(R.id.descriptioncontent);
        mLocationText = (TextView) findViewById(R.id.locationcontent);
        mDisText = (TextView) findViewById(R.id.discontent);
        mVoteText = (TextView) findViewById(R.id.votecontent);
        
        Button preview = (Button) findViewById(R.id.map);
        final Button cancel = (Button) findViewById(R.id.back);
        
        ImageButton thumbUp = (ImageButton) findViewById(R.id.thumbup);
    	thumbUp.setImageResource(R.drawable.thumb_up);

    	ImageButton thumbDown = (ImageButton) findViewById(R.id.thumbdown);
    	thumbDown.setImageResource(R.drawable.thumb_down);
        
        Bundle extras = getIntent().getExtras();
        mRowId = extras.getLong(RealDealDbAdapter.KEY_ROWID);

    	cancel.requestFocus();
        populateFields();
        
    	preview.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				goMap();
			}
		});
    	    	
    	cancel.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				setResult(RESULT_CANCELED, null, null);
                finish();
			}
		});
    	
    	thumbUp.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				uv = uv + 1;
				tv = tv + 1;
				mDbHelper.updatePromotion(mRowId, null, null, null, null, -1, null, (int)uv, (int)tv);
				promotionMenu(icicle);
				cancel.requestFocus();
			}
		});
    	
    	thumbDown.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				tv = tv + 1;
				mDbHelper.updatePromotion(mRowId, null, null, null, null, -1, null, (int)uv, (int)tv);
				promotionMenu(icicle);
				cancel.requestFocus();
			}
		});
    }
    
    private void populateFields() 
    {  	
    	if (mRowId != null) 
    	{
    		mPromotion = mDbHelper.fetchPromotion(mRowId);
            startManagingCursor(mPromotion);
            mStoreNameText.setText(mPromotion.getString(
            		mPromotion.getColumnIndex(RealDealDbAdapter.KEY_STORENAME)));
            mTypeText.setText(mPromotion.getString(
            		mPromotion.getColumnIndex(RealDealDbAdapter.KEY_TYPE)));
            mDescriptionText.setText(mPromotion.getString(
            		mPromotion.getColumnIndex(RealDealDbAdapter.KEY_DESCRIPTION)));
            mLocationText.setText(mPromotion.getString(
            		mPromotion.getColumnIndex(RealDealDbAdapter.KEY_LOCATION)));
            
            double f = mPromotion.getDouble(
            		mPromotion.getColumnIndex(RealDealDbAdapter.KEY_DIS));
            String s = new Double(f).toString();
            mDisText.setText(s);
                        
            uv = (Integer)mPromotion.getInt(mPromotion.getColumnIndex(RealDealDbAdapter.KEY_UPVOTE));
            tv = (Integer)mPromotion.getInt(mPromotion.getColumnIndex(RealDealDbAdapter.KEY_TOTALVOTE));
            mVoteText.setText(uv.toString() + "/" + tv.toString());
    	}
    }
    
    public final static int ACTIVITY_MAP = 10;
    
    public void goMap() {
    	if (mRowId != null) {
    		Intent i = new Intent(this, MyDrivingDirectionsActivity.class);
    		mPromotion = mDbHelper.fetchPromotion(mRowId);
    		startManagingCursor(mPromotion);
	    	double lat = mPromotion.getDouble(
	        		mPromotion.getColumnIndex(RealDealDbAdapter.KEY_LAT));
	    	double log = mPromotion.getDouble(
	    			mPromotion.getColumnIndex(RealDealDbAdapter.KEY_LONGI));
	    	double dis = mPromotion.getDouble(
	    			mPromotion.getColumnIndex(RealDealDbAdapter.KEY_DIS));
	    	i.putExtra("latitude", lat);
	    	i.putExtra("longitude", log);
	    	i.putExtra("distance", dis);
	    	startSubActivity(i, ACTIVITY_MAP);
    	}
    }
    
	@Override
	protected void onFreeze(Bundle outState) {
		// TODO Auto-generated method stub
		super.onFreeze(outState);
	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		
	}
    
	protected void onActivityResult(int requestCode, int resultCode,
			String data, Bundle extras) {
		// TODO Auto-generated method stub
		super.onActivityResult(requestCode, resultCode, data, extras);
		switch(requestCode) 
		{
        case ACTIVITY_MAP:
        	break;
		}
	}
}