package edu.berkeley.edu.cs160.groupjybz.realdealprototype;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import org.w3c.dom.*;
import org.xml.sax.SAXException;

import javax.xml.parsers.*;
import java.io.InputStream;

import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.ImageView;
import android.widget.Button;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu.Item;

import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Point;
//import com.google.googlenav.Placemark;
//import com.google.googlenav.Search;
import com.google.googlenav.map.Map;
import com.google.googlenav.map.MapPoint;
import com.google.googlenav.map.Zoom;
import com.google.android.maps.*;
import android.location.LocationManager;
import android.location.Location;
import android.location.Geocoder;
import android.location.Address;
import com.google.googlenav.DrivingDirection;

public class RealDealMap extends MapActivity {
	private MapView mMapView;
	private MapController mController;
	private OverlayController mOverlayController;
	private Point mCurrentPoint;
	private LocationManager locationManager;
	private Location location;
	private static final int ZOOM_IN = 0;
	private static final int ZOOM_OUT = 1;
	private static final int TOGGLE_SAT = 2;
	private static final int TOGGLE_TRAFFIC = 3;
	private static final int BACK = 4;
	private Point[] points=null;// = new Point[2];
	private Address address[]=null;
	
	public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        mMapView = new MapView(this);
        mController = mMapView.getController();
        mOverlayController = mMapView.createOverlayController();
        mCurrentPoint = new Point((int) (37.816402 * 1000000), (int)
                (-122.225078 * 1000000));
        mController.animateTo(mCurrentPoint);
        mController.zoomTo(12);
        
        
        if(address != null) {
        	points = new Point[2];
        	Point point = new Point ((int) address[0].getLatitude() * 1000000, 
        		(int) address[0].getLongitude() * 1000000);
        	points[1]=point;
        } else {
        	//points = new Point[1];
        	points = new Point[2];
        	Point point = new Point((int) (37.826402 * 1000000), (int)
                    (-122.265078 * 1000000));
        	points[1]=point;
        }
        
        points[0]=mCurrentPoint;
        MapOverlay myLocationOverlay = new MapOverlay(points);
        mOverlayController.add(myLocationOverlay, true);
        
        /*locationManager = (LocationManager)getSystemService(this.LOCATION_SERVICE);
        location = locationManager.getCurrentLocation("gps");*/
        setContentView(mMapView);
        //updateView();
    }

	public void updateView() {
		Double lat = location.getLatitude()*1E6;
		Double lng = location.getLongitude()*1E6;
		Point point = new Point(lat.intValue(), lng.intValue());
		mController.centerMapTo(point, false);
	}
	
    public boolean onKeyDown(int keyCode, KeyEvent event) {
    	if (keyCode == KeyEvent.KEYCODE_DPAD_UP) {
    		int level = mMapView.getZoomLevel();
    		int lat = mCurrentPoint.getLatitudeE6();
    		int log = mCurrentPoint.getLongitudeE6();
    		mCurrentPoint = new Point((int) (lat+40000/level), (int)
                    (log));
    		mController.animateTo(mCurrentPoint);
    		return true;
    	} else if (keyCode == KeyEvent.KEYCODE_DPAD_DOWN) {
    		int level = mMapView.getZoomLevel();
    		int lat = mCurrentPoint.getLatitudeE6();
    		int log = mCurrentPoint.getLongitudeE6();
    		mCurrentPoint = new Point((int) (lat-40000/level), (int)
                    (log));
    		mController.animateTo(mCurrentPoint);
    		return true;
    	} else if (keyCode == KeyEvent.KEYCODE_DPAD_RIGHT) {
    		int level = mMapView.getZoomLevel();
    		int lat = mCurrentPoint.getLatitudeE6();
    		int log = mCurrentPoint.getLongitudeE6();
    		mCurrentPoint = new Point((int) (lat), (int)
                    (log+40000/level));
    		mController.animateTo(mCurrentPoint);
    		return true;
    	} else if (keyCode == KeyEvent.KEYCODE_DPAD_LEFT) {
    		int level = mMapView.getZoomLevel();
    		int lat = mCurrentPoint.getLatitudeE6();
    		int log = mCurrentPoint.getLongitudeE6();
    		mCurrentPoint = new Point((int) (lat), (int)
                    (log-40000/level));
    		mController.animateTo(mCurrentPoint);
    		return true;
    	} else if (keyCode == KeyEvent.KEYCODE_I) {
            // Zoom In
            int level = mMapView.getZoomLevel();
            mMapView.getController().zoomTo(level + 1);
            return true;
        } else if (keyCode == KeyEvent.KEYCODE_O) {
            // Zoom Out
            int level = mMapView.getZoomLevel();
            mMapView.getController().zoomTo(level - 1);
            return true;
        } else if (keyCode == KeyEvent.KEYCODE_S) {
            // Switch on the satellite images
            mMapView.toggleSatellite();
            return true;
        } else if (keyCode == KeyEvent.KEYCODE_T) {
            // Switch on traffic overlays
            mMapView.toggleTraffic();
            return true;
        } else if (keyCode == KeyEvent.KEYCODE_BACK) {
        	setResult(RESULT_OK, null, null);
            finish();
            return true;
        }
        return false;
    }
    
    public boolean onCreateOptionsMenu(Menu menu) {
		//each represent a feature
		menu.add(0, ZOOM_IN, R.string.zoom_in);
		menu.add(0, ZOOM_OUT, R.string.zoom_out);
		menu.add(0, TOGGLE_SAT, R.string.toggle_sat);
		menu.add(0, TOGGLE_TRAFFIC, R.string.toggle_traffic);
		menu.add(0, BACK, R.string.back);
		return super.onCreateOptionsMenu(menu);
	}
    
	public boolean onMenuItemSelected(int featureId, Item item) {
		switch(item.getId()) {
        case ZOOM_IN:  
            int levela = mMapView.getZoomLevel();
            mMapView.getController().zoomTo(levela + 1);
            return true;
        case ZOOM_OUT:  
            int levelb = mMapView.getZoomLevel();
            mMapView.getController().zoomTo(levelb - 1);
            return true;
        case TOGGLE_SAT:  
            mMapView.toggleSatellite();
            return true;
        case TOGGLE_TRAFFIC:  
            mMapView.toggleTraffic();
            return true;
        case BACK:
        	setResult(RESULT_OK, null, null);
            finish();
            return true;
        }
        return super.onMenuItemSelected(featureId, item);
	}
	
	
	
}